<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
	<title>Buck's Score Card</title>
	<link rel="stylesheet" href="style.css">
</head>

<body>
    <div id="scoreTallyBlock">
        <div class="scoreParentHeader">Opportunity Score</div>
        <div id="scoreTallyParent" class="scoreTallyParent">
            <table cellpadding=0 cellborder=0 id='scoreTallyParent'><tr><td>
                <td valign='top'>
                    <div id="OpTallyRating" class="OpTallyRatingText"></div>
                </td>
                <td>
                    <div id="tallyBarBlock">
                        <canvas id="tallyMarkBackground"></canvas>
                        <div id="tallyMarkProgressBar"></div>
                        <div class="tallyMark upperMark">
                        </div>
                        <div class="tallyMark lowerMark">
                        </div>
                    </div>
                </td>
                <td id="entryListCell"></td>
            </tr></table>
        </div>
        <div id="console"></div>
        <script>
            var defaultTopics={
                    "Exposure":10,
                    "Passion":10,
                    "Relationship":10,
                    "Impact":10,
                    "Utilization":10,
                    "Additional Biz":10,
                    "Internal IP":10,
                    "Profit":10,
                    "Client Knowledge":10
                };
            var scores=["Nah.", "Not quite...", "Go for it!"]; 
            var scoreColors=["#a06a00", "#d8a109", "#0dd928"];
            var curScoreLetter=scores[0];
            var topics={};
            var totalScore=0;
            
            function clearCookies(){
                var cookieCutter=document.cookie;
                cookieCutter=cookieCutter.split("; ");
                cookieCutter.map((e)=>{
                    document.cookie=e.split("=")[0]+"=;expires=Thu, 01 Jan 1970 00:00:00 GMT"
                });
            }
            function rebuildCookies(){
                clearCookies();
                topics={...defaultTopics};
                let keys=Object.keys(topics);
                keys.sort();

                for(let x=0; x<keys.length; ++x){
                    setCookie( keys[x], topics[keys[x]] );
                }
            }
            function setTopicArray(){ // There should be cookies no matter, might be running local on machine
                let cookieCutter=document.cookie;
                console.log(cookieCutter);
                if(cookieCutter==""){
                    topics={...defaultTopics};
                    return
                }
                topics={};
                cookieCutter=cookieCutter.split("; ");
                cookieCutter.map((e)=>{
                    let val=e.split("=");
                    topics[val[0]]=val[1];
                });
            }
            function setEntryValues(){
                let keys=Object.keys(topics);
                keys.sort();
                
                let checkboxes=document.getElementById("scoreTallyBlock").querySelectorAll("*[type='checkbox']")
                let curVal=0;
                totalScore=0;
                let buttonCount=0;
                for(let x=0; x<checkboxes.length; ++x){
                    let title=x<keys.length?keys[x]:'';
                    let val=x<keys.length?topics[keys[x]]:0;
                    document.getElementById("consoleEntryTitle_"+x).value=title;
                    document.getElementById("tallyEntryValue_"+x).value=val;
                }
            }
            function setCookie(key,val){
                let d = new Date();
                let daysTil=30;
                d.setTime(d.getTime() + (daysTil*24*60*60*1000));
                let exp = "expires="+ d.toUTCString();
                document.cookie=key+"="+val+";"+exp;
            }

            function resetSettings(){
                rebuildCookies();
                setEntryValues();
                gatherScores();
            }
            function updateScore(id, entry){
                let checked=entry.checked
                gatherScores();
            }
            function gatherScores(){
                let checkboxes=document.getElementById("scoreTallyBlock").querySelectorAll("*[type='checkbox']")
                let curVal=0;
                totalScore=0;
                let buttonCount=0;
                for(let x=0; x<checkboxes.length; ++x){
                    let curcb=checkboxes[x];
                    let id=curcb.value;
                    let entryNameDom=document.getElementById("tallyEntryText_"+id).value;
                    document.getElementById("consoleEntryTitle_"+id).innerText=entryNameDom;
                    if(entryNameDom!="" && typeof(entryNameDom)=="string"){
                        buttonCount+=1;
                        let entryValDom=document.getElementById("tallyEntryValue_"+id);
                        let curWeight=parseInt(entryValDom.value);
                        setCookie(entryNameDom, curWeight);
                        document.getElementById("consoleEntryWeight_"+id).innerText=curWeight;
                        totalScore+=curWeight;
                        if(curcb.checked){
                            curVal+=curWeight;
                        }
                    }
                }
                let scoreValue=Math.min(1,curVal/(totalScore*.21));
                curScoreLetter=scores[parseInt((scores.length-1)*(scoreValue))];

                let scoreDisplay=document.getElementById("OpTallyRating");
                scoreDisplay.innerText=curScoreLetter;
                scoreDisplay.style.color=scoreColors[parseInt((scoreColors.length-1)*(scoreValue))];;

                let tallyMarker=document.getElementById("tallyMarkProgressBar");
                scoreValue=Math.min(98,Math.max(2, curVal/(totalScore*.32)*100));
                tallyMarker.style.bottom=scoreValue+"%";

                document.getElementById("consoleCurScore").innerText=curVal;
                document.getElementById("consoleTotalScore").innerText=totalScore;
            }
            function scoreTallyFormSubmit(e){
                let formData=new FormData(document.getElementById("ScoreTallyForm"));
                let keys=Object.keys(topics);
                keys.sort();
                let al="Project score of: "+curScoreLetter+"\n---\n";
                for(let x=0; x<keys.length; ++x){
                    al+=formData.get(keys[x])!=null?keys[x]+"\n":"";
                }
                alert(al);
            }
            function checkEnter(dom,e, id){
                if(e.keyCode==13){
                    dom.blur();
                }else{
                    gatherScores();
                }
            }
            function fixValue(field, id){
                let val=parseInt(field.value);
                val=isNaN(val)?0:val;
                field.value=val;
                gatherScores();
            }
            function prepTallyMarker(){
                let parent=document.getElementById("scoreTallyParent");
                let tallyCanvas=document.getElementById("tallyMarkBackground");
                let res=[50, parent.offsetHeight];
                tallyCanvas.width=res[0];
                tallyCanvas.height=res[1];
                let ctx=tallyCanvas.getContext("2d");
                let grd=ctx.createLinearGradient(0,0, 0,res[1]);
                grd.addColorStop(1,scoreColors[0]);
                grd.addColorStop(.5,scoreColors[1]);
                grd.addColorStop(0,scoreColors[2]);
                ctx.fillStyle=grd;
                ctx.fillRect(0,0, ...res);
            }

            // Initial boot
            {
                var OpScoreCookie=document.cookie;
                if(OpScoreCookie==""){
                    rebuildCookies();
                }
                setTopicArray();

                document.getElementById("OpTallyRating").innerText=scores[0];
                let parent=document.getElementById("entryListCell");

                let html="";
                let buttonValues="";

                let keys=Object.keys(topics);
                keys.sort();
                html+="<form id='ScoreTallyForm'><table cellpadding=0 cellborder=0 border=0 id='ScoreTallyTable'>";
                let run=keys.length+5;
                for(let x=0; x<run; ++x){
                    let curTitle=x<keys.length?keys[x]:'';
                    let curScore=x<keys.length?parseInt(topics[keys[x]]):0;
                    totalScore+=curScore;
                    html+="<tr><td class='entryId'>"+(x+1)+".</td>";
                    html+=`
                        <td>
                            <label class="button">
                                <input type="checkbox" class="button-inner" onclick="updateScore('`+x+`', this)" id="`+curTitle+`" name="`+curTitle+`" value="`+x+`">
                                <div id="checkbox_`+x+`" class="checkbox"></div>
                            </label>
                        </td>`;
                    html+="<td><input type='text' id='tallyEntryText_"+x+"' value='"+curTitle+"' onkeyup='checkEnter(this,event, "+x+")' class='tallyHeader' size=20></td>";
                    html+="<td><input type='text' id='tallyEntryValue_"+x+"' value='"+curScore+"' onkeypress='fixValue(this, "+x+")' onkeyup='fixValue(this, "+x+")' onblur='fixValue(this)' class='tallyScore' size=3></td>";
                    html+="</td></tr>";
                    buttonValues+="<br><span id='consoleEntryTitle_"+x+"' class='bold'>"+curTitle+"</span> -- <span id='consoleEntryWeight_"+x+"'  class='bold bigger'>"+curScore+"</span>";
                
                }
                html+="</table><input type='button' value='Submit' class='submit' onclick='scoreTallyFormSubmit()'> --- <input type='button' value='Reset' class='submit' onclick='resetSettings()'></form>"
                parent.innerHTML=html;
                buttonValues="[ <span class='bold'>"+keys.length+"</span> Buttons; with total value of <span id='consoleCurScore' class='bold'>0</span>/<span id='consoleTotalScore' class='bold'>"+totalScore+"</span> ]"+buttonValues;
                document.getElementById("console").innerHTML=buttonValues;
                prepTallyMarker();
            }
        </script>
    </div>
</body>
</html>
